function  [window_STFT,window_LPC,Ulog_STFT,Ulog_LPC]=...
    get_window_correction(iwin_STFT,iwin_LPC,L);
%
% Inputs:
%   iwin_STFT: window type for STFT analysis
%   iwin:LPC: window type for LPC/cepstrum analysis
%   L: length of window in samples
%  
% Outputs:
%   window_STFT: STFT window
%   window_LPC: LPC/cepstral window
%   Ulog_STFT: log magnitude correction for STFT window
%   Ulog_LPC: log magnitude correction for LPC/cepstrum analysis window

% windows and log correction for STFT windows
    if (iwin_STFT == 1)
        window_STFT=hamming(L)';
        U_STFT=sum(window_STFT.^2);
    elseif (iwin_STFT == 2)
        window_STFT=ones(1,L);
        U_STFT=L;
    end
    
    Ulog_STFT=10*log10(U_STFT);
    
% windows and log correction for LPC/cepstral windows
    if (iwin_LPC == 1)
        window_LPC=hamming(L)';
        U_LPC=sum(window_LPC.^2);
    elseif (iwin_LPC == 2)
        window_LPC=ones(1,L);
        U_LPC=L;
    end
    
    Ulog_LPC=10*log10(U_LPC);
end
