function plot_frame(x,ss,L,fs,iwin_STFT,graphicPanel);
%
% function to plot speech frame using designated STFT window 

% Inputs:
%   x: current speech file, sampling rate: fsd
%   ss: starting sample in speech file for display of frames
%   L: initial duration of speech frame in samples
%   fs: speech file sampling rate
%   iwin_STFT: STFT window type (1:Hamming, 2:Rectangular)
%   graphicPanel: graphic panel in which speech frame plot to be shown

% create frame of speech
        if (iwin_STFT == 1)
            xw=x(ss:ss+L-1).*hamming(L);
        else
            xw=x(ss:ss+L-1);
        end
    
% clear graphics panel
    reset(graphicPanel);
    axes(graphicPanel);
    
% plot input signal over three regions
    plot(ss:ss+L-1,xw(1:L),'b','LineWidth',2);
    xpp=['Time in Samples; fs=',num2str(fs),' samples/second'];
    xlabel(xpp),ylabel('Value'),grid on, axis tight;
    leg=['speech frame L=',num2str(L)];
    legend(leg);
end